package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayTenantBo;
import com.ruoyi.pay.domain.vo.PayTenantVo;
import com.ruoyi.pay.domain.PayTenant;
import com.ruoyi.pay.mapper.PayTenantMapper;
import com.ruoyi.pay.service.IPayTenantService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 租户Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayTenantServiceImpl implements IPayTenantService {

    private final PayTenantMapper baseMapper;

    /**
     * 查询租户
     */
    @Override
    public PayTenantVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询租户列表
     */
    @Override
    public TableDataInfo<PayTenantVo> queryPageList(PayTenantBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayTenant> lqw = buildQueryWrapper(bo);
        Page<PayTenantVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询租户列表
     */
    @Override
    public List<PayTenantVo> queryList(PayTenantBo bo) {
        LambdaQueryWrapper<PayTenant> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayTenant> buildQueryWrapper(PayTenantBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayTenant> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), PayTenant::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getPhone()), PayTenant::getPhone, bo.getPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getFixPhone()), PayTenant::getFixPhone, bo.getFixPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), PayTenant::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getWebsite()), PayTenant::getWebsite, bo.getWebsite());
        return lqw;
    }

    /**
     * 新增租户
     */
    @Override
    public Boolean insertByBo(PayTenantBo bo) {
        PayTenant add = BeanUtil.toBean(bo, PayTenant.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改租户
     */
    @Override
    public Boolean updateByBo(PayTenantBo bo) {
        PayTenant update = BeanUtil.toBean(bo, PayTenant.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayTenant entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除租户
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
